import { EntitySchema } from "./schemas/Entity";
export declare type NormalizationResultType = string | string[] | NormalizationResultObject;
interface NormalizationResultObject extends Record<string, NormalizationResultType> {
}
export declare type NormalizationOutput<ResultType, Entities> = {
    result: ResultType;
    entities: Entities;
};
export declare type ValidKey = string | number | symbol;
export declare type ValueOf<T> = T[keyof T];
export interface Schema<Input extends Record<ValidKey, any>, Name extends string, ResultType extends NormalizationResultType, EntitiesOutput extends Record<string, Record<string, any>>> {
    nameProp: Name;
    normalizeWith(input: Input, parent: any, objectKey: string | undefined): NormalizationOutput<ResultType, EntitiesOutput>;
}
export declare class PropBuilder<SchemaName extends string> {
    schemaName: SchemaName;
    constructor(input: SchemaName);
    build<InputType extends Record<ValidKey, any>, EntitiesOutput extends Record<string, Record<string, any>>, S extends EntitySchema<InputType, any, SchemaName, any, EntitiesOutput>>(schemas: Record<SchemaName, S>): Schema<InputType, SchemaName, any, EntitiesOutput>;
}
export interface SchemaPropBuilder<SchemaName extends string, SchemaType extends EntitySchema<any, any, SchemaName, any, any>> extends PropBuilder<SchemaName> {
    schema: SchemaType;
    basePropBuilder(): PropBuilder<SchemaName>;
}
export declare type ValidSchemaProp<T extends string> = T | PropBuilder<T> | SchemaPropBuilder<T, any>;
export declare type ExtractSchemaNames<T extends AnySchema> = T extends Schema<any, infer N, any, any> ? N : never;
export declare type AnySchema = Schema<any, any, any, any>;
export {};
